// FftWinView.cpp : CFftWinView NX̓̒`s܂B
// by Toshio Iwata at digitalfilter.com 2004/09/16

#include "stdafx.h"
#include "FftWin.h"

#include "FftWinDoc.h"
#include "FftWinView.h"
#include "DlgWinSel.h"
#include "DlgRng.h"
#include "DlgFftPos.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFftWinView

IMPLEMENT_DYNCREATE(CFftWinView, CView)

BEGIN_MESSAGE_MAP(CFftWinView, CView)
	//{{AFX_MSG_MAP(CFftWinView)
	ON_COMMAND(ID_MENU_LD, OnMenuLd)
	ON_COMMAND(ID_MENU_WINSEL, OnMenuWinsel)
	ON_COMMAND(ID_MENU_RNG, OnMenuRng)
	ON_COMMAND(ID_MENU_FFTPOS, OnMenuFftpos)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFftWinView NX̍\z/

CFftWinView::CFftWinView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	spec_range = 160.0;
	freq_range = 44100.0;
	mono1_stereo2 = 1;
	samplingfreq = 44100;
	bitlength = 8;
	totalbytes = 44100;
	bytesinfile = 44100;
	chbytes_per_sample = 1;
	bytes_per_sample = 1;
	bytes_per_sec = 44100;
	wavesize = 44100;
	timelength = 1;
	dotn = 500;
	allocated = FALSE;
	loaded = FALSE;
	xstart = 0;
	yrng = 10000;
	WinType = 0;
	fft_position = 20;
}

CFftWinView::~CFftWinView()
{
}

BOOL CFftWinView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CFftWinView NX̕`

void CFftWinView::OnDraw(CDC* pDC)
{
	CFftWinDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	if(loaded) {
		InfoDraw(pDC, 80, 20);
		WinFuncCal(WinType);
		FftCal(InWave, Spectrum);		
		FftDraw(pDC, 60, 100, Spectrum);
	} else {
		pDC->TextOut( 50, 50, "FftWin.exe");
		pDC->TextOut( 50, 80, "lXȑ֐Ƃ̌ʁB");
		pDC->TextOut( 50, 110, "uWavet@Cvuǂݍ݁vIĂB");
		pDC->TextOut( 50, 140, "by DIGITALFILTER.COM");
	}
}

/////////////////////////////////////////////////////////////////////////////
// CFftWinView NẌ

BOOL CFftWinView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CFftWinView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CFftWinView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CFftWinView NX̐ff

#ifdef _DEBUG
void CFftWinView::AssertValid() const
{
	CView::AssertValid();
}

void CFftWinView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFftWinDoc* CFftWinView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFftWinDoc)));
	return (CFftWinDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFftWinView NX̃bZ[W nh
void CFftWinView::OnMenuLd() 
{
	GetWavInfo();
	InvalidateRect(NULL, TRUE);
}

void CFftWinView::GetWavInfo()
{
	unsigned long len;
	unsigned char s[10];
	int i;
	long fmtbytes;
	FILE *ifp;
	CString filenameld;
	CFileDialog dlgF(TRUE, "NULL", "*.wav");

	if( dlgF.DoModal() == IDOK)	{
		filenameld = dlgF.GetPathName();
		ifp = fopen( filenameld, "rb" );
		if (ifp != NULL) {
			fread(s, 4, 1, ifp); // "RIFF" 
			bytesinfile = get_ulong(ifp); // total bytes in the file
			fread(s, 8, 1, ifp); // "WAVEfmt" 
			fmtbytes = get_ulong(ifp); // header size
			len = get_ushort(ifp); // 1: pcm
			mono1_stereo2 = get_ushort(ifp); // 1: mono, 2; stereo
			samplingfreq = get_ulong(ifp); // sampling frequency
			bytes_per_sec = get_ulong(ifp); // bytes per second
			chbytes_per_sample = get_ushort(ifp); // channels * bytes per sample
			bitlength = get_ushort(ifp); // bit length
			if( bitlength == 16 ) yrng = 10000; else yrng = 100;
			xstart = 0;
			for (i = 0; i < (fmtbytes-16)/2; i++ ) {
				len = get_ushort(ifp); // skip redundant header information
			}
			do{ // look for "data" chunk
				fread(s, 4, 1, ifp); // expect "data"
				if(((s[0] == 'd')&(s[1] == 'a')&(s[2] == 't')&(s[3] == 'a')) == 0){ // step over chunks unless it's "data" chunk
					len = get_ulong(ifp);
					fseek(ifp, len, SEEK_CUR);
				}else{
					break ;
				}
			} while(1);
			totalbytes = get_ulong(ifp); // total bytes of wav data
			bytes_per_sample = bitlength / 8;
			wavesize = totalbytes / (mono1_stereo2 * bytes_per_sample);
			timelength = (double)wavesize/(double)samplingfreq;
			freq_range = (double)samplingfreq;
			if(bitlength == 16) spec_range = 160;
			else spec_range = 160;
			int i, m;
			short x;
			AllocateMemory();
			if (mono1_stereo2 == 1) {
				for (i = 0; i < wavesize; i++) { // read mono wav data
					if (fread(s, bytes_per_sample, 1, ifp) != 1) break;
					if (bytes_per_sample == 2) x = (short)(s[0] + 256 * s[1]);
					else x = (short)(s[0]) - 128;
					InWave[i] = (double)(x);
				}
			} else {
				for (i = 0; i < wavesize * 2; i++) { // read stereo wav data
					m = i / 2;
					if (fread(s, bytes_per_sample, 1, ifp) != 1) break;
					if (bytes_per_sample == 2) x = (short)(s[0] + 256 * s[1]);
					else x = (short)(s[0]) - 128;
					if(i%2==0) InWave[m] = (double)(x);
					else InWaveR[m] = (double)(x);
				}
			}
			fclose( ifp );
			loaded = TRUE;
		}
	}
}

unsigned long CFftWinView::get_ulong(FILE *f)
{
    unsigned char s[4];
	unsigned res;

    if (fread(s, 4, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0] + 256LU * (s[1] + 256LU * (s[2] + 256LU * s[3]));
	}
    return res;
}

unsigned CFftWinView::get_ushort(FILE *f)
{
    unsigned char s[2];
	unsigned res;

    if (fread(s, 2, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0] + 256U * s[1];
	}
    return res;
}

unsigned CFftWinView::get_ubyte(FILE *f)
{
    unsigned char s[1];
	unsigned res;

    if (fread(s, 1, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0];
	}
    return res;
}

void CFftWinView::AllocateMemory()
{
	if( allocated ) {
		free(InWave);
		free(InWaveR);
	}
	InWave = (double *)calloc(wavesize, sizeof(double));
	InWaveR = (double *)calloc(wavesize, sizeof(double));
	allocated = TRUE;
}

void CFftWinView::InfoDraw(CDC *pDC, int x1, int y1)
{
	char tmpchar[12];

	if( mono1_stereo2 == 1 ) pDC->TextOut( x1 + 10, y1 + 10, "Mono");
	else pDC->TextOut( x1 + 10, y1 + 10, "Stereo");

	pDC->TextOut( x1 + 80, y1 + 10, "Sampling Freq");
	sprintf(tmpchar,"%6d", samplingfreq);
	pDC->TextOut( x1 + 80, y1 + 30, tmpchar);

	pDC->TextOut( x1 + 200, y1 + 10, "Bit Length");
	sprintf(tmpchar,"%3d", bitlength);
	pDC->TextOut( x1 + 200, y1 + 30, tmpchar);

	pDC->TextOut( x1 + 300, y1 + 10, "Total Bytes");
	sprintf(tmpchar,"%8d", totalbytes);
	pDC->TextOut( x1 + 300, y1 + 30, tmpchar);

	pDC->TextOut( x1 + 400, y1 + 10, "Time Length");
	sprintf(tmpchar,"%7.4f", timelength);
	pDC->TextOut( x1 + 400, y1 + 30, tmpchar);
}

void CFftWinView::FftCal(double *InW, double *OutW)
{
	int N = 256; 
	int P; 
	double Pi = 3.1415928;
	int N_2 = N/2;
	int i,j,k,kp,m,h;
	double m_double;
	double w1, w2;
	double t1,t2,s1,s2;
	double fReal[256], fImag[256], tri[256];
	int offset;

	i = N; P = 0;
	while (i != 1) {
		i = i / 2;
		P++;
	}

	offset = wavesize * fft_position / 100; 
	if( offset + N >= wavesize ) offset = wavesize - N;
	for (i = 0; i < N; i++) {
		fReal[i] = InW[i + offset] * WinFunc[i]; // ֐̏Z
		fImag[i] = 0.0;
	}

	for ( i = 0; i < N_2; i++ ) {
		tri[i] = cos( 2 * i * Pi / N );
		tri[i + N_2] = (-1.0) * sin( 2 * i * Pi / N );
	}

	j = 0;
	for ( i = 0; i <= N-2; i++ ) {
		if (i < j) {
			t1 = fReal[j]; fReal[j] = fReal[i]; fReal[i] = t1;
			t2 = fImag[j]; fImag[j] = fImag[i]; fImag[i] = t2;
		}
		k = N_2;
		while (k <= j) {
			j = j - k; k = k/2;
		}
		j = j + k;
	}

	for ( i = 1; i <= P; i++ ) {
		m_double = pow(2.0, double(i));
		m = int(m_double);
		h = m/2;
		for ( j = 0; j < h; j++ ) {
			w1 = tri[j*(N/m)];
			w2 = tri[j*(N/m) + N_2];
			for( k = j; k < N; k+=m ) {
				kp = k + h;
				s1 = fReal[kp] * w1 - fImag[kp] * w2;
				s2 = fReal[kp] * w2 + fImag[kp] * w1;
				t1 = fReal[k] + s1; fReal[kp] = fReal[k] - s1; fReal[k] = t1;
				t2 = fImag[k] + s2; fImag[kp] = fImag[k] - s2; fImag[k] = t2;
			}
		}
	}

	for ( i = 0; i < N; i++ ) {
		OutW[i] = sqrt(fReal[i] * fReal[i] + fImag[i] * fImag[i]);
	}
}

void CFftWinView::FftDraw(CDC *pDC, int x0, int y0, double *Xfr)
{
	double start_fr, end_fr, mid_fr;
	double tmp_xfr[256];
	int	i;
	char freq_char[15];
	char mag_char[15];
	int yscale = 160;
	int xscale = 510;
	double xstep = 2.0;
	int N = 256;

	CPen	myPen;
	CPen*	pOldPen;
	
	start_fr = 0.0;
	end_fr = freq_range;
	mid_fr = freq_range / 2.0;

	sprintf(freq_char,"%9.1f", start_fr);
	pDC->TextOut(x0 - 50, y0 + yscale + 10, freq_char);
	sprintf(freq_char,"%9.1f", mid_fr);
	pDC->TextOut(x0 + 220, y0 + yscale + 10, freq_char);
	sprintf(freq_char,"%9.1f", end_fr);
	pDC->TextOut(x0 + 460, y0 + yscale + 10, freq_char);
	pDC->TextOut(x0 + 540, y0 + yscale + 10,"[Hz]");

	if( WinType == 1 ) pDC->TextOut(x0 + 200, y0 - 25, "Hanning");
	else if( WinType == 2 ) pDC->TextOut(x0 + 200, y0 - 25, "Hamming");
	else if( WinType == 3 ) pDC->TextOut(x0 + 200, y0 - 25, "Blackman");
	else if( WinType == 4 ) pDC->TextOut(x0 + 200, y0 - 25, "Blackman-Harris");
	else if( WinType == 5 ) pDC->TextOut(x0 + 200, y0 - 25, "Bartlett");
	else  pDC->TextOut(x0 + 200, y0 - 25, "֐Ȃ(Rectangle)");

	pDC->TextOut(x0 - 30, y0 - 35,"[dB]");
	pDC->TextOut(x0 - 20, y0 - 10,"0");
	sprintf(mag_char,"%5.0f", -spec_range*1/4 );
	pDC->TextOut(x0 - 50, y0 + 30, mag_char);
	sprintf(mag_char,"%5.0f", -spec_range*2/4 );
	pDC->TextOut(x0 - 50, y0 + 70, mag_char);
	sprintf(mag_char,"%5.0f", -spec_range*3/4 );
	pDC->TextOut(x0 - 50, y0 + 110, mag_char);
	sprintf(mag_char,"%5.0f", -spec_range*4/4 );
	pDC->TextOut(x0 - 50, y0 + 150, mag_char);
	
	myPen.CreatePen(PS_DOT, 1, RGB(100,100,100));
	pOldPen = pDC->SelectObject(&myPen);

	for(i = 1; i < 8; i++) {
		pDC->MoveTo(x0, y0 + i * yscale/8);
		pDC->LineTo(x0 + xscale, y0 + i * yscale/8);
	}

	for(i = 0; i <= 10; i++) {
		pDC->MoveTo(x0 + i * (xscale / 10), y0);
		pDC->LineTo(x0 + i * (xscale / 10), y0 + yscale);
	}

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	pDC->MoveTo(x0, y0);
	pDC->LineTo(x0 + xscale, y0);
	pDC->MoveTo(x0, y0 + yscale);
	pDC->LineTo(x0 + xscale, y0 + yscale);
	pDC->MoveTo(x0, y0);
	pDC->LineTo(x0, y0 + yscale);
	pDC->MoveTo(x0 + xscale, y0);
	pDC->LineTo(x0 + xscale, y0 + yscale);
	
	myPen.CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
	pOldPen = pDC->SelectObject(&myPen);

	for(i = 0; i < 256; i++) {
		if(Xfr[i] != 0) {
			if( bitlength == 16 ) 
				tmp_xfr[i] = 20.0 * log10(Xfr[i] / N / pow(2, 15)) * yscale/spec_range; 
			else 
				tmp_xfr[i] = 20.0 * log10(Xfr[i] / N / pow(2, 7)) * yscale/spec_range; 
		} else {
			tmp_xfr[i] = -160; 
		}
	}

	xstep = 2.0 * samplingfreq / freq_range;

	for(i = 0; i < 256-1; i++) {
		if( (i+1)*xstep <= xscale ) {
			pDC->MoveTo(x0 + (int)(i*xstep), y0 - (int)(tmp_xfr[i]));
			pDC->LineTo(x0 + (int)((i+1)*xstep), y0 - (int)(tmp_xfr[i+1]));
		}
	}

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();
}

void CFftWinView::WinFuncCal(int wintype)
{
	int N = 256; 
	int i;
	double Pi = 3.1415926;

	if( wintype == 1 ) { // Hanning
		for( i = 0; i < N; i++ ) {
			WinFunc[i] = 0.5 * ( 1.0 - cos(Pi * 2 * i / (N-1)) ); 
		}
	} else if( wintype == 2 ) { // Hamming
		for( i = 0; i < N; i++ ) {
			WinFunc[i] = 0.54 - 0.46 * cos(Pi * 2 * i / (N-1)); 
		}
	} else if( wintype == 3 ) { // Blackman
		for( i = 0; i < N; i++ ) {
			WinFunc[i] = 0.42 - 0.5 * cos(Pi * 2 * i / (N-1)) 
					+ 0.08 * cos(2.0 * Pi * 2 * i / (N-1)); 
		}
	} else if( wintype == 4 ) { // Blackman-Harris
		double a0 = 0.35875;
		double a1 = 0.48829;
		double a2 = 0.14128;
		double a3 = 0.01168;
		for( i = 0; i < N; i++ ) {
			WinFunc[i] = a0 - a1 * cos(Pi * 2 * (i+0.5) / N) 
					+ a2 * cos(Pi * 2 * 2.0 * (i+0.5) / N) 
					- a3 * cos(Pi * 2 * 3.0 * (i+0.5) / N);
		}
	} else if( wintype == 5 ) { // Bartlett
		for( i = 0; i <= (N-1)/2; i++ ) {
			WinFunc[i] = 2.0 * i / (N-1);
		}
		for( i = (N-1)/2; i < N; i++ ) {
			WinFunc[i] = 2.0 - 2.0 * i / (N-1);
		}
	} else { // No Window (Rectangle)
		for( i = 0; i < N; i++ ) {
			WinFunc[i] = 1.0; 
		}
	}
}

void CFftWinView::OnMenuWinsel() 
{
	CDlgWinSel dlg;

	dlg.m_wintype = WinType;
	if (dlg.DoModal() == IDOK) {
		WinType = dlg.m_wintype;
		InvalidateRect(NULL, TRUE);
	}	
}

void CFftWinView::OnMenuRng() 
{
	CDlgRng dlg;

	dlg.m_srng = spec_range;
	dlg.m_frng = freq_range;
	if (dlg.DoModal() == IDOK) {
		spec_range = dlg.m_srng;
		freq_range = dlg.m_frng;
		InvalidateRect(NULL, TRUE);
	}	
}

void CFftWinView::OnMenuFftpos() 
{
	CDlgFftPos dlg;

	dlg.m_fftpos = fft_position;
	if (dlg.DoModal() == IDOK) {
		fft_position = dlg.m_fftpos;
		InvalidateRect(NULL, TRUE);
	}	
}

void CFftWinView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CRect rectClient;
	GetClientRect(&rectClient);
	pDC -> SetMapMode(MM_ANISOTROPIC);
	pDC -> SetWindowOrg(0,0);
	pDC -> SetWindowExt(100,50);
	pDC -> SetViewportOrg(0,0);
	pDC -> SetViewportExt(550, 350); // `TCYݒ

	CFont* pfontCurrent = pDC -> GetCurrentFont();
	LOGFONT lfCurrentFont;
	pfontCurrent -> GetObject(sizeof(LOGFONT), &lfCurrentFont);
	CFont fontBig;
	lfCurrentFont.lfHeight = 12; // tHgTCYijݒ
	lfCurrentFont.lfWidth = 6; // tHgTCYijݒ

	fontBig.CreateFontIndirect(&lfCurrentFont);
	CFont* defaultFont = (CFont*)pDC -> SelectObject(&fontBig);

	CView::OnPrint(pDC, pInfo);
}
